#include <assert.h>
#include "umfpack.h"

//=============================================================================
int solver (Matrice &iA, Vecteur &ib, Vecteur &ix)
//=============================================================================
  {
  // verifier si les dimensions sont bonnes
  int dim = iA.RetDim();
  int n = dim;
  double Info [UMFPACK_INFO], Control [UMFPACK_CONTROL];
/*  int* Ap = iA.lignesind;
  double* b = ib.valeurs;
  int* Ai = iA.colonnes;
  double* Ax = iA.valeurs;
  
  double* x = new double[n];*/
   
/**/   

//   cout << iA << endl;


   int* Ap = new int[n+1];// = {0, 2, 5, 9, 10, 12} ;
   double* x = new double[n];
   double* b = new double[n];
   int totnz = iA.lignesind[n]; // total number of non zero elements in the matrix
//   cout << "n = " << n << "totnz = " << totnz << endl;
   int * Ai = new int[totnz];
   double *Ax = new double[totnz];

   for (int i=0;i<totnz;i++)
   {
    Ai[i] = iA.colonnes[i];
    Ax[i] = iA.valeurs[i];
//    cout << "input i ="<<i<< " colonnes " << Ai[i] << " valeurs " << Ax[i] << endl;
   }/**/
   for (int i=0;i<n;i++)       b[i] = ib[i];
   for (int i=0;i<=n;i++) 
   {
      Ap[i] = iA.lignesind[i];
//      cout << "Ap["<<i<<"] = "<<Ap[i]<<endl;
   }
//if (1==0)
{  
  double *null = (double *) NULL ;
  int i, status;
  void *Symbolic, *Numeric ;
  status =  umfpack_di_symbolic (n, n, Ap, Ai, Ax, &Symbolic, Control, Info) ;
  if (status < 0)
  {
        umfpack_di_report_info (Control, Info) ;
	umfpack_di_report_status (Control, status) ;
      cout << "umfpack_di_symbolic	 failed" << endl;
  }
  
  
  status = umfpack_di_numeric (Ap, Ai, Ax, Symbolic, &Numeric, Control, Info) ;
  if (status < 0)
  {
      umfpack_di_report_info (Control, Info) ;
      umfpack_di_report_status (Control, status) ;
      cout << "umfpack_di_numeric failed" << endl;
  }
				      
  umfpack_di_free_symbolic (&Symbolic) ;
  
   status = umfpack_di_solve (UMFPACK_A, Ap, Ai, Ax, x, b, Numeric, Control, Info) ;
   if (status < 0) cout << "umfpack_di_solve failed" << endl ;


   (void) umfpack_di_report_vector (n, x, Control) ;      
      
   umfpack_di_free_numeric (&Numeric) ;
  for (i = 0 ; i < n ; i++) 
  {
//    printf ("x [%d] = %g\n", i, x [i]) ;
    ix[i] = x[i];
  }
}  
 delete [] Ai;
 delete [] Ax;
 delete [] x;
 delete [] Ap;
 delete [] b;
    return 0;
}


