#ifndef LIGNE_H
#define LIGNE_H

#include <iostream.h>
#include "sommet.h"

//! Classe d'une ligne de matrice creuse.
class Ligne {

public:

  int nbcoef;                   //!< Nombre actuel des coefficients non nuls.
  double valeurs[MAXVOIS + 1];  //!< Valeurs non nulles.
  int colonnes[MAXVOIS + 1];    //!< Colonnes des valeurs non nulles.

  //! Constructeur.
  Ligne ();

  //! Destructeur.
  ~Ligne ();

  //! Operateur d'acces aux elements de la ligne.
  double operator [] (int i) const;

  //! Operateur de changement / creation des entrees.
  double & operator [] (int i);

  //! Fonction d'annulation de toutes les entrees.
  void Zero ();

};

#endif
