#include "triangle.h"

//=============================================================================
EZTriangle::EZTriangle ()
//=============================================================================
{
}

//=============================================================================
EZTriangle::EZTriangle (Sommet* som1, Sommet* som2, Sommet* som3, double df, double sr)
//=============================================================================
{
  sommets[0] = som1;
  sommets[1] = som2;
  sommets[2] = som3;

  dif = df;
  sour = sr;
}

//=============================================================================
EZTriangle::~EZTriangle ()
//=============================================================================
{
}

//=============================================================================
void EZTriangle::Geometrie ()
//=============================================================================
{
  mes = (sommets[1]->x - sommets[0]->x) * (sommets[2]->y - sommets[0]->y)
        - (sommets[2]->x - sommets[0]->x) * (sommets[1]->y - sommets[0]->y);
  for (int i = 0; i < 3; i++) {
    fonctbas[i][0] = - (sommets[(i + 2) % 3]->y - sommets[(i + 1) % 3]->y) / mes;
    fonctbas[i][1] = - (sommets[(i + 1) % 3]->x - sommets[(i + 2) % 3]->x) / mes;
  }
  mes /= 2.0;
}

